package com.dataguise.combinesmallfiles.avro;

import com.dataguise.combinesmallfiles.text.WordOffset;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.util.StringTokenizer;

/**
 * Created by shiyanghuang on 17/12/14.
 */
public class AvroMap extends Mapper<Object, Object, Text, IntWritable> {

    private final static IntWritable one = new IntWritable(1);
    private Text word = new Text();
    Logger logger = Logger.getLogger(AvroMap.class);

    public void map(Object key, Object value, Context context)
            throws IOException, InterruptedException {
        WordOffset wKey = (WordOffset) key;
        logger.info("Filename: " + wKey.fileName);
        logger.info("Offset: " + wKey.offset);
        logger.info("Index: " + wKey.index);

        logger.info("Value: " + value);
        String line = value.toString();
        StringTokenizer itr = new StringTokenizer(line);
        while (itr.hasMoreTokens()) {
            word.set(itr.nextToken());
            context.write(word, one);
        }
    }
}
