package com.dataguise.combinesmallfiles.orc;

import com.dataguise.combinesmallfiles.text.WordOffset;
import org.apache.hadoop.hive.ql.io.orc.OrcStruct;
import org.apache.hadoop.mapreduce.InputSplit;
import org.apache.hadoop.mapreduce.RecordReader;
import org.apache.hadoop.mapreduce.TaskAttemptContext;
import org.apache.hadoop.mapreduce.lib.input.CombineFileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.CombineFileRecordReader;
import org.apache.hadoop.mapreduce.lib.input.CombineFileSplit;

import java.io.IOException;

public class ORCCombineInputFormat extends CombineFileInputFormat<WordOffset, OrcStruct> {

	public ORCCombineInputFormat(){
	    super();
	    setMaxSplitSize(268435456); // 256 MB, default split size on hadoop
	}
	
	@SuppressWarnings("unchecked")
	public RecordReader<WordOffset, OrcStruct> createRecordReader(InputSplit split, TaskAttemptContext context) throws IOException {
          return new CombineFileRecordReader<WordOffset, OrcStruct>((CombineFileSplit)split, context, ORCCombineRecordReader.class);
    }

}