package com.dataguise.combinesmallfiles.orc;

/**
 * Created by shiyanghuang on 17/12/14.
 */

import com.dataguise.combinesmallfiles.text.WordOffset;
import org.apache.hadoop.hive.ql.io.orc.OrcStruct;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.util.StringTokenizer;

/**
 * This Mapper is similar to the one in .
 */
public class ORCMap extends
        Mapper<Object, OrcStruct, Text, IntWritable> {
    private final static IntWritable one = new IntWritable(1);
    private Text word = new Text();
    Logger logger = Logger.getLogger(ORCMap.class);

    public void map(Object key, OrcStruct value, Context context)
            throws IOException, InterruptedException {
        WordOffset wKey = (WordOffset) key;
        logger.info("Key offset: " + wKey.offset);
        logger.info("Key fileName: " + wKey.fileName);
        logger.info("Key index: " + wKey.index);
        logger.info("Value: " + value);

        String line = value.toString();
        StringTokenizer itr = new StringTokenizer(line);
        while (itr.hasMoreTokens()) {
            word.set(itr.nextToken());
            context.write(word, one);
        }
    }
}