package com.dataguise.combinesmallfiles.parquet;

import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.InputSplit;
import org.apache.hadoop.mapreduce.RecordReader;
import org.apache.hadoop.mapreduce.TaskAttemptContext;
import org.apache.hadoop.mapreduce.lib.input.CombineFileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.CombineFileRecordReader;
import org.apache.hadoop.mapreduce.lib.input.CombineFileSplit;

import java.io.IOException;

/**
 * Created by shiyanghuang on 17/12/14.
 */

/**
 * To use {@link org.apache.hadoop.mapreduce.lib.input.CombineFileInputFormat}, one should extend it, to return a
 * (custom) {@link org.apache.hadoop.mapreduce.RecordReader}. CombineFileInputFormat uses
 * {@link org.apache.hadoop.mapreduce.lib.input.CombineFileSplit}s.
 */
//public class CombineParquetInputFormat extends CombineFileInputFormat {
//
//    @Override
//    public RecordReader createRecordReader(InputSplit inputSplit, TaskAttemptContext context) throws IOException {
//        return new CombineFileRecordReader((CombineFileSplit)inputSplit, context, CombineParquetRecordReader.class);
//    }
//}

public class ParquetCombineInputFormat<T> extends CombineFileInputFormat<Text, T> {


    @Override
    public RecordReader<Text, T> createRecordReader(InputSplit split, TaskAttemptContext
            context) throws IOException {
        CombineFileSplit combineSplit = (CombineFileSplit) split;
        return new CombineFileRecordReader(combineSplit, context, ParquetCombineRecordReader.class);
    }
}
