package com.dataguise.combinesmallfiles.parquet;

import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.TaskAttemptContext;
import org.apache.hadoop.mapreduce.lib.input.CombineFileRecordReaderWrapper;
import org.apache.hadoop.mapreduce.lib.input.CombineFileSplit;
import org.apache.parquet.hadoop.ParquetInputFormat;
import org.apache.parquet.hadoop.example.GroupReadSupport;

import java.io.IOException;

/**
 * Created by shiyanghuang on 17/12/20.
 */
public class ParquetCombineRecordReader<T> extends CombineFileRecordReaderWrapper<Text, T> {

    Path path;
    public ParquetCombineRecordReader(CombineFileSplit split, TaskAttemptContext context, Integer idx) throws
            IOException, InterruptedException {
        super(new ParquetInputFormat(GroupReadSupport.class), split, context, idx);
        path = split.getPath(idx);
    }

    @Override
    public Text getCurrentKey() {
        return new Text(path.toString());
    }
}
