package com.dataguise.combinesmallfiles.parquet;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.log4j.Logger;
import org.apache.parquet.example.data.Group;

import java.io.IOException;
import java.util.StringTokenizer;


/**
 * Created by shiyanghuang on 17/12/14.
 */
public class ParquetMap extends Mapper<Object, Object, Text, IntWritable> {

    private final static IntWritable one = new IntWritable(1);
    private Text word = new Text();
    Logger logger = Logger.getLogger(ParquetMap.class);

    public void map(Object key, Object value, Context context)
            throws IOException, InterruptedException {
        logger.info("Key: " + key);
        logger.info("Value: " + value);
        Group group = (Group)value;
        logger.info("Group: " + group);
        String line = value.toString();
        StringTokenizer itr = new StringTokenizer(line);
        while (itr.hasMoreTokens()) {
            word.set(itr.nextToken());
            context.write(word, one);
        }
    }
}
