package com.dataguise.combinesmallfiles.rc;

import org.apache.hadoop.mapreduce.InputSplit;
import org.apache.hadoop.mapreduce.RecordReader;
import org.apache.hadoop.mapreduce.TaskAttemptContext;
import org.apache.hadoop.mapreduce.lib.input.CombineFileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.CombineFileRecordReader;
import org.apache.hadoop.mapreduce.lib.input.CombineFileSplit;

import java.io.IOException;

/**
 * RCFileInputFormat.
 * 
 * This is the new MR API input format for RC file.  Borrowed from Internet.
 * 
 * The old MR API uses org.apache.hadoop.hive.ql.io.RCFileInputFormat.
 * 
 * There is no input format from new MR API.  This surprised me a lot. At least,
 * I did not find it.
 * 
 * There is an one at HCatalog:  org.apache.hcatalog.rcfile.RCFileMapReduceInputFormat
 * But I really do not want to depend on HCatalog.
 *
 */
public class RCCombineFileInputFormat extends CombineFileInputFormat  {

	public RCCombineFileInputFormat() {
        super();
        setMaxSplitSize(268435456); // 256 MB, default split size on hadoop
	}

    @Override
	public RecordReader createRecordReader(InputSplit split, TaskAttemptContext context)
			throws IOException {
        return new CombineFileRecordReader((CombineFileSplit)split, context, RCCombineFileRecordReader.class);
	}
}
