package com.dataguise.combinesmallfiles.sequence;

import org.apache.hadoop.mapreduce.InputSplit;
import org.apache.hadoop.mapreduce.RecordReader;
import org.apache.hadoop.mapreduce.TaskAttemptContext;
import org.apache.hadoop.mapreduce.lib.input.CombineFileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.CombineFileRecordReader;
import org.apache.hadoop.mapreduce.lib.input.CombineFileSplit;

import java.io.IOException;

public class SequenceCombineInputFormat extends CombineFileInputFormat {

	public SequenceCombineInputFormat(){
	    super();
	    setMaxSplitSize(268435456); // 256 MB, default split size on hadoop
	}
	
	@SuppressWarnings("unchecked")
	public RecordReader createRecordReader(InputSplit split, TaskAttemptContext context) throws IOException {
          return new CombineFileRecordReader((CombineFileSplit)split, context, SequenceCombineRecordReader.class);
    }

}