package com.dataguise.combinesmallfiles.sequence;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.io.Writable;
import org.apache.hadoop.io.WritableComparable;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.util.StringTokenizer;


/**
 * Created by shiyanghuang on 17/12/14.
 */
public class SequencetMap extends Mapper<WritableComparable, Writable, Text, IntWritable> {

    private final static IntWritable one = new IntWritable(1);
    private Text word = new Text();
    Logger logger = Logger.getLogger(SequencetMap.class);

    public void map(WritableComparable key, Writable value, Context context)
            throws IOException, InterruptedException {
        logger.info("Key: " + key);
        logger.info("Value: " + value);
        String line = value.toString();
        StringTokenizer itr = new StringTokenizer(line);
        while (itr.hasMoreTokens()) {
            word.set(itr.nextToken());
            context.write(word, one);
        }
    }
}
