package com.dataguise.combinesmallfiles.text;

/**
 * Created by shiyanghuang on 17/12/14.
 */

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.lib.input.CombineFileSplit;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.util.StringTokenizer;

/**
 * This Mapper is similar to the one in .
 */
public class MapClass extends
        Mapper<WordOffset, Text, Text, IntWritable> {
    private final static IntWritable one = new IntWritable(1);
    private Text word = new Text();
    Logger logger = Logger.getLogger(MapClass.class);

    public void map(WordOffset key, Text value, Context context)
            throws IOException, InterruptedException {

//        logger.info("Key: " + key);
        CombineFileSplit cfs = (CombineFileSplit) context.getInputSplit();
        int index = key.index;
        logger.info("Index: " + index);
//        logger.info("Path: " + cfs.getPath(index));
//        logger.info("Offset: " + cfs.getOffset(index));
//        logger.info("StartOffsets: " + cfs.getStartOffsets().length);
//        logger.info("Locations: " + cfs.getLocations());
//        logger.info("Value: " + value);

        String line = value.toString();
        logger.info("String: " + line);
        StringTokenizer itr = new StringTokenizer(line);
        while (itr.hasMoreTokens()) {
            word.set(itr.nextToken());
            context.write(word, one);
        }
    }
}