package com.dataguise.combinesmallfiles.text;

/**
 * Created by shiyanghuang on 17/12/14.
 */

import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.InputSplit;
import org.apache.hadoop.mapreduce.RecordReader;
import org.apache.hadoop.mapreduce.TaskAttemptContext;
import org.apache.hadoop.mapreduce.lib.input.CombineFileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.CombineFileRecordReader;
import org.apache.hadoop.mapreduce.lib.input.CombineFileSplit;

import java.io.IOException;

/**
 * To use {@link org.apache.hadoop.mapreduce.lib.input.CombineFileInputFormat}, one should extend it, to return a
 * (custom) {@link org.apache.hadoop.mapreduce.RecordReader}. CombineFileInputFormat uses
 * {@link org.apache.hadoop.mapreduce.lib.input.CombineFileSplit}s.
 */
public class MyInputFormat
        extends CombineFileInputFormat<WordOffset, Text> {

    public MyInputFormat() {
        super();
        setMaxSplitSize(1234);
    }
    public RecordReader<WordOffset,Text> createRecordReader(InputSplit split,
                                                            TaskAttemptContext context) throws IOException {
        return new CombineFileRecordReader<WordOffset, Text>(
                (CombineFileSplit)split, context, CombineFileLineRecordReader.class);
    }
}