package com.dataguise.filesystem;

import com.dataguise.util.Config;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileStatus;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

/**
 * Created by shiyanghuang on 17/11/28.
 */
public class FileSystemTest {
    public static void main(String[] args) throws URISyntaxException {
        Configuration conf = new Configuration();
        Config.setConf(conf);
        new FileSystemTest().FileSystemTest(conf);
    }
    public void FileSystemTest(Configuration conf) throws URISyntaxException {
        FileSystem fs = null;
        String pathStr = "/dataguise$/tmp/lib/";

        Path path = new Path(pathStr);

        try {
            fs = FileSystem.get(new URI(pathStr), conf);
            System.out.println("Get FS");
        } catch (IOException e) {
            System.out.println("Cannot get FileSystem. " + e);
        }

        System.out.println("Home directory :" + fs.getHomeDirectory());
        System.out.println("List root directory :");

        String localPath = "/Users/shiyanghuang/Documents/Dataguise/John1/../Parquet/parquetlib";
        File file = new File(localPath);

        String[] files = file.list();
        String currentdir = getClass().getClassLoader().getResource("").toString();

        File cfile = new File(currentdir);
        String abs = null;

        abs = currentdir.substring(5);

        System.out.println("Current DIR: " + abs);
        try {
            FileStatus[] status = fs.listStatus(path);
            for (FileStatus st : status) {
                System.out.println(st.getPath() + " : " + st.getLen());
            }

            for (String f : files) {
                File ff = new File(localPath + "/" + f);
                System.out.println(ff.getPath() + " : " + ff.length());
            }

        } catch (IOException e) {
            System.out.println("Cannot get root dir list" + e);
        }
    }
}
