package com.dataguise.mapreduce;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.util.StringTokenizer;

/**
 * Created by shiyanghuang on 17/11/28.
 */
public class mapreduceMap extends Mapper<LongWritable, Text, Text, IntWritable> {
    private final static IntWritable one = new IntWritable(1);
    private Text word = new Text();
    private Logger logger = Logger.getLogger(mapreduceMap.class);
    public void map(LongWritable key, Text value, Context context) throws IOException, InterruptedException {
        String line = value.toString();
        logger.info("Length: " + line.length());
        int k = 0;
        logger.debug("K debug = " + (k++));
        logger.info("K info = " + k);
        line = line.trim();
        // logger.info("Logger: " + line);
        byte[] bytes = value.getBytes();
        line = new String(bytes, "UTF-8");
        StringTokenizer tokenizer = new StringTokenizer(line);
        while (tokenizer.hasMoreTokens()) {
            word.set(tokenizer.nextToken());
            context.write(word, one);
        }
    }
}