package com.dataguise.singleton;

import com.dataguise.util.Config;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FSDataOutputStream;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.security.UserGroupInformation;

import java.io.IOException;
import java.net.URI;
import java.security.PrivilegedExceptionAction;

/**
 * Created by shiyanghuang on 18/2/26.
 */
public class AWSTest {
    public static void main(String[] args) throws IOException {
        Configuration conf = new Configuration();
        String path = "/Users/shiyanghuang/Documents/Dataguise/aws/conf/conf";

        conf.set("dfs.client.use.datanode.hostname", "true");
        Config.setConf(path, conf);
        FileSystemTest(conf);
    }
    public static void FileSystemTest(Configuration conf) throws IOException {

        String user = "hdfs";
        UserGroupInformation ugi = UserGroupInformation.createRemoteUser(user);
        final Configuration fconf = conf;
        try {

            ugi.doAs(new PrivilegedExceptionAction() {

                public Void run() throws Exception {
                    FileSystem fs = null;
                    try {
                        fs = FileSystem.get(new URI(""),fconf);
                        System.out.println("Get FS");
                    } catch (IOException e) {
                        System.out.println("Cannot get FileSystem. " + e);
                    }

                    Path path = new Path("/dataguise$/test/test");
                    if (fs.exists(path) && fs.isFile(path)) {
                        fs.delete(path, true);
                    }
                    System.out.println(fconf.get("dfs.replication"));
                    System.out.println(fconf.get("dfs.namenode.name.dir"));
                    FSDataOutputStream fstream = null;
                    try {
                        fstream = fs.create(path);
                        System.out.println("Fstream created");
                        fstream.write("TEST".getBytes());
                        System.out.println("TEST wrote");
                        fstream.flush();
                        System.out.println("Flushed");
                    } catch (Throwable e) {
                        e.printStackTrace();
                    } finally {
                        if (fstream != null) {
                            fstream.close();
                            System.out.println("Close");
                        }
                    }

                    return null;
                }

            });

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
