package com.dataguise.singleton;

import com.dataguise.util.Config;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.ContentSummary;
import org.apache.hadoop.fs.FileStatus;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;

import java.io.IOException;

/**
 * Created by shiyanghuang on 17/12/5.
 */
public class FileSystemSingleton {
    public static void main(String[] args) throws IOException {
        Configuration conf = new Configuration();
        String path = "/Users/shiyanghuang/Documents/Dataguise/hdp_conf/conf";
        path = "/etc/hadoop/conf";
        Config.setConf(path, conf);
        FileSystemTest(conf);
        // fileSizeTest(conf);
    }

    private static void fileSizeTest(Configuration conf) {
        FileSystem fs = null;
        try {
            fs = FileSystem.get(conf);

            String path = "/test50files/test50.txt";
            path = "/fileStatus/sample.csv";
            FileStatus fstatus = fs.getFileStatus(new Path(path));

            System.out.println(fstatus.getLen());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void FileSystemTest(Configuration conf) throws IOException {
        FileSystem fs = null;
        try {
            fs = FileSystem.get(conf);
            System.out.println("Get FS");
        } catch (IOException e) {
            System.out.println("Cannot get FileSystem. " + e);
        }

        System.out.println("Home directory :" + fs.getHomeDirectory());
        System.out.println("List root directory :");
        ContentSummary cs = fs.getContentSummary(new Path("/"));
        System.out.println("ContentSummary" + cs);
        try {
            FileStatus[] status = fs.listStatus( new Path("/") );
            for (FileStatus st : status) {
                System.out.println(st.getPath());
            }
        } catch (IOException e) {
            System.out.println("Cannot get root dir list" + e);
        }
    }
}
